Overview | Package | Class | Tree | Deprecated | Index | Help
| Protege 3.4 rc2
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## edu.stanford.smi.protege.model
Class DefaultKnowledgeBase

    java.lang.Object
      edu.stanford.smi.protege.model.DefaultKnowledgeBase

All Implemented Interfaces:
  KnowledgeBase, Disposable

    public class DefaultKnowledgeBase

extends Object
implements KnowledgeBase

Default implementation of the KnowledgeBase interface. Delegates almost everything to the FrameStore chain. Implements wrapper methods for some calls to make the interface easier to use.

Author:
  Ray Fergerson (fergerson@smi.stanford.edu)

Field Summary
`static String` | `SERVER_PROCESS_USER`

Fields inherited from interface edu.stanford.smi.protege.model.KnowledgeBase
`MAXIMUM_CARDINALITY_UNBOUNDED, UNLIMITED_MATCHES`

Constructor Summary
`DefaultKnowledgeBase()`
`DefaultKnowledgeBase(KnowledgeBaseFactory factory)`

Method Summary
`void` | `addClsListener(Cls cls, ClsListener listener)` Add a listener for class events for a particular class
`void` | `addClsListener(ClsListener listener)` Add a listener for class events for all classes
`void` | `addDirectSuperclass(Cls cls, Cls superclass)`
`void` | `addDirectSuperslot(Slot slot, Slot superslot)`
`void` | `addDirectTemplateSlot(Cls cls, Slot slot)`
`void` | `addDirectType(Instance instance, Cls directType)`
`void` | `addDirectTypes(Instance instance, Collection types)`
`void` | `addFacetListener(Facet facet, FacetListener listener)` Add a listener for facet events for a particular facet
`void` | `addFacetListener(FacetListener listener)` Add a listener for facet events for all facets
`void` | `addFrameListener(Frame frame, FrameListener listener)` add a listener fro frame evnets for a particular frame
`void` | `addFrameListener(FrameListener listener)` add a listener for frame events for all frames
`void` | `addInstance(Instance instance, String name, Cls type, boolean isNew)` TODO: Implement addInstance
`void` | `addInstanceListener(Instance instance, InstanceListener listener)`
`void` | `addInstanceListener(InstanceListener listener)`
`void` | `addJavaLoadPackage(String packageName)` This method requires some background information.
`void` | `addKnowledgeBaseListener(KnowledgeBaseListener listener)`
`void` | `addOwnSlotValue(Frame frame, Slot slot, Object value)` Deprecated. use #addDirectOwnSlotValues
`void` | `addServerProjectListener(ServerProjectListener listener)`
`void` | `addSlotListener(SlotListener listener)`
`void` | `addSlotListener(Slot slot, SlotListener listener)`
`void` | `addTemplateFacetValue(Cls cls, Slot slot, Facet facet, Object value)` Deprecated. use #setDirectTemplateFacetValues
`void` | `addTemplateSlotValue(Cls cls, Slot slot, Object value)` Deprecated. use #setDirectTemplateSlotValues
`void` | `addTransactionListener(TransactionListener listener)`
`protected void` | `adjustForClient()`
`protected void` | `adjustForServer()`
`boolean` | `areValidOwnSlotValues(Frame frame, Slot slot, Collection values)`
`void` | `assertFrameName(Frame frame)`
`boolean` | `beginTransaction(String name)` Tells the system that one or more edit actions will follow which should be handled as a unit for undo.
`boolean` | `beginTransaction(String name, String appliedToFrameName)`
`void` | `clearAllListeners()`
`void` | `close()`
`boolean` | `commitTransaction()` Commits the recently opened transaction
`boolean` | `containsFrame(String name)`
`Cls` | `createCls(FrameID id, Collection directSuperclasses, Collection directTypes, boolean loadDefaults)`
`Cls` | `createCls(String name, Collection superclasses)`
`Cls` | `createCls(String name, Collection superclasses, Cls directType)`
`Cls` | `createCls(String name, Collection superclasses, Cls directType, boolean initializeDefaults)`
`Cls` | `createCls(String name, Collection directSuperclasses, Collection directTypes, boolean loadDefaults)`
`Facet` | `createFacet(FrameID id, Collection directTypes, boolean initializeDefaults)`
`Facet` | `createFacet(String name)`
`Facet` | `createFacet(String name, Cls directType)`
`Facet` | `createFacet(String name, Cls directType, boolean initializeDefaults)`
`protected FrameFactory` | `createFrameFactory()`
`protected FrameStoreManager` | `createFrameStoreManager()`
`Instance` | `createInstance(FrameID id, Cls directType, boolean initializeDefaults)`
`Instance` | `createInstance(FrameID id, Collection directTypes, boolean initializeDefaults)`
`Instance` | `createInstance(String name, Cls directType)`
`Instance` | `createInstance(String name, Cls directType, boolean initializeDefaults)`
`Instance` | `createInstance(String name, Collection directTypes)`
`SimpleInstance` | `createSimpleInstance(FrameID id, Cls directType, boolean loadDefaults)`
`SimpleInstance` | `createSimpleInstance(FrameID id, Collection types, boolean loadDefaults)`
`SimpleInstance` | `createSimpleInstance(String name, Cls directType, boolean loadDefaults)`
`Slot` | `createSlot(FrameID id, Collection directTypes, Collection superslots, boolean loadDefaults)`
`Slot` | `createSlot(String name)`
`Slot` | `createSlot(String name, Cls directType)`
`Slot` | `createSlot(String name, Cls directType, boolean loadDefaults)`
`Slot` | `createSlot(String name, Cls directType, Collection superslots, boolean loadDefaults)`
`protected SystemFrames` | `createSystemFrames()`
`String` | `createUniqueFrameName(String name)` Deprecated. no longer needed
`void` | `deleteCls(Cls cls)`
`void` | `deleteFacet(Facet facet)`
`void` | `deleteFrame(Frame frame)`
`void` | `deleteInstance(Instance instance)`
`void` | `deleteSimpleInstance(SimpleInstance simpleInstance)`
`void` | `deleteSlot(Slot slot)`
`void` | `dispose()`
`boolean` | `endTransaction()` Deprecated. Use #commitTransaction
`boolean` | `endTransaction(boolean doCommit)` Deprecated. Use #commitTransaction or #rollbackTransaction
`static boolean` | `equals(Object o1, Object o2)`
`Collection<Frame>` | `executeQuery(Query q)`
`void` | `flushCache()`
`void` | `flushEvents()`
`Collection` | `getAllowedClses(Slot slot)`
`Collection` | `getAllowedParents(Slot slot)`
`Collection` | `getAllowedValues(Slot slot)`
`boolean` | `getAllowsMultipleValues(Slot slot)`
`Facet` | `getAssociatedFacet(Slot slot)`
`Slot` | `getAssociatedSlot(Facet facet)`
`String` | `getBrowserText(Instance instance)`
`String` | `getBuildString()` Returns a string that contains something like "build 840" that refers to the build of Protege in use when this kb was last saved.
`ServerCacheStateMachine` | `getCacheMachine()`
`Object` | `getClientInformation(Object key)` Allows a programmer to hang arbitrary information on a kb and retrieve it later.
`Cls` | `getCls(String name)`
`int` | `getClsCount()`
`Collection<Cls>` | `getClses()`
`Collection<Cls>` | `getClsesWithMatchingBrowserText(String s, Collection superclasses, int maxMatches)`
`Collection` | `getClsNameMatches(String name, int maxMatches)` Get classes whose name matches the give string.
`CommandManager` | `getCommandManager()`
`Collection` | `getCurrentUsers()`
`Cls` | `getDefaultClsMetaCls()` If no meta class is specified when a class is created the system uses the metaclass of the first specified parent.
`Cls` | `getDefaultFacetMetaCls()`
`Cls` | `getDefaultSlotMetaCls()`
`Collection` | `getDefaultValues(Slot slot)`
`BrowserSlotPattern` | `getDirectBrowserSlotPattern(Cls cls)`
`Collection` | `getDirectDomain(Slot slot)`
`int` | `getDirectInstanceCount(Cls cls)`
`Collection<Instance>` | `getDirectInstances(Cls cls)`
`Collection` | `getDirectlyOverriddenTemplateFacets(Cls cls, Slot slot)`
`Collection` | `getDirectlyOverriddenTemplateSlots(Cls cls)`
`Object` | `getDirectOwnSlotValue(Frame frame, Slot slot)`
`List` | `getDirectOwnSlotValues(Frame frame, Slot slot)`
`Set` | `getDirectOwnSlotValuesClosure(Frame frame, Slot slot)`
`int` | `getDirectSubclassCount(Cls cls)`
`Collection` | `getDirectSubclasses(Cls cls)`
`int` | `getDirectSubslotCount(Slot slot)`
`Collection` | `getDirectSubslots(Slot slot)`
`int` | `getDirectSuperclassCount(Cls cls)`
`Collection<Cls>` | `getDirectSuperclasses(Cls cls)`
`int` | `getDirectSuperslotCount(Slot slot)`
`Collection` | `getDirectSuperslots(Slot slot)`
`List` | `getDirectTemplateFacetValues(Cls cls, Slot slot, Facet facet)`
`Collection` | `getDirectTemplateSlots(Cls cls)`
`List` | `getDirectTemplateSlotValues(Cls cls, Slot slot)`
`Cls` | `getDirectType(Instance instance)`
`Collection` | `getDirectTypes(Instance instance)`
`boolean` | `getDispatchEventsEnabled()`
`protected String` | `getDisplaySlotNotSetString(Instance instance)`
`protected String` | `getDisplaySlotPatternValueNotSetString(Instance instance, BrowserSlotPattern slotPattern)`
`Collection` | `getDocumentation(Frame frame)`
`Collection` | `getDomain(Slot slot)`
`boolean` | `getEventsEnabled()` Deprecated. Use #getGenerateEventsEnabled(boolean)
`Facet` | `getFacet(String name)`
`boolean` | `getFacetCheckingEnabled()`
`int` | `getFacetCount()`
`Collection` | `getFacets()`
`Frame` | `getFrame(FrameID id)`
`Frame` | `getFrame(String name)`
`int` | `getFrameCount()`
`FrameCounts` | `getFrameCounts()`
`String` | `getFrameCreationTimestamp(Frame frame)`
`String` | `getFrameCreator(Frame frame)`
`FrameFactory` | `getFrameFactory()`
`String` | `getFrameLastModificationTimestamp(Frame frame)`
`String` | `getFrameLastModifier(Frame frame)`
`Collection<Frame>` | `getFrameNameMatches(String name, int maxMatches)`
`String` | `getFrameNamePrefix()`
`Collection` | `getFrames()`
`FrameStoreManager` | `getFrameStoreManager()`
`List<FrameStore>` | `getFrameStores()` Returns a list of FrameStores available to the system.
`Set` | `getFramesWithMatchingDirectOwnSlotValue(Slot slot, String value, int maxMatches)`
`Collection` | `getFramesWithValue(Slot slot, Facet facet, boolean isTemplate, Object value)` Gets frames with a particular own/template slot/facet value.
`boolean` | `getGenerateEventsEnabled()`
`FrameStore` | `getHeadFrameStore()`
`Collection` | `getInheritedTemplateSlots(Cls cls)`
`Instance` | `getInstance(String name)`
`int` | `getInstanceCount(Cls cls)`
`Collection<Instance>` | `getInstances()`
`Collection<Instance>` | `getInstances(Cls cls)` Deprecated.
`String` | `getInvalidFrameNameDescription(String name, Frame frame)`
`String` | `getInvalidOwnSlotValuesText(Frame frame, Slot slot, Collection values)`
`String` | `getInvalidOwnSlotValueText(Frame frame, Slot slot, Object value)`
`Slot` | `getInverseSlot(Slot slot)`
`KnowledgeBaseFactory` | `getKnowledgeBaseFactory()`
`Collection` | `getMatchingFrames(Slot slot, Facet facet, boolean isTemplate, String value, int maxMatches)` Finds all occurances of a string in the knowledge base.
`Collection<Reference>` | `getMatchingReferences(String s, int maxRefs)`
`int` | `getMaximumCardinality(Slot slot)`
`Integer` | `getMaximumCardinality2(Slot slot)`
`Number` | `getMaximumValue(Slot slot)`
`int` | `getMinimumCardinality(Slot slot)`
`Number` | `getMinimumValue(Slot slot)`
`protected String` | `getMissingTypeString(Instance instance)`
`String` | `getName()`
`String` | `getName(Frame frame)`
`Slot` | `getNameSlot()`
`int` | `getNextFrameNumber()` Deprecated. No longer implemented
`Collection` | `getOverriddenTemplateFacets(Cls cls, Slot slot)`
`Collection` | `getOverriddenTemplateSlots(Cls cls)`
`Collection` | `getOwnFacets(Frame frame, Slot slot)`
`Collection` | `getOwnFacetValues(Frame frame, Slot slot, Facet facet)`
`boolean` | `getOwnSlotAllowsMultipleValues(Frame frame, Slot slot)`
`Collection` | `getOwnSlotAndSubslotValues(Frame frame, Slot slot)` Deprecated. use getOwnSlotValues
`Collection` | `getOwnSlotDefaultValues(Frame frame, Slot slot)`
`Collection` | `getOwnSlotFacets(Frame frame, Slot slot)` Deprecated. renamed to #getOwnFacets
`Collection` | `getOwnSlotFacetValues(Frame frame, Slot slot, Facet facet)` Deprecated. renamed to #getOwnFacetValues
`Collection<Slot>` | `getOwnSlots(Frame frame)`
`Object` | `getOwnSlotValue(Frame frame, Slot slot)`
`int` | `getOwnSlotValueCount(Frame frame, Slot slot)`
`Collection` | `getOwnSlotValues(Frame frame, Slot slot)`
`ValueType` | `getOwnSlotValueType(Frame frame, Slot slot)`
`Project` | `getProject()`
`Collection` | `getReachableSimpleInstances(Collection rootInstances)`
`Collection` | `getReachableSimpleInstances(Frame frame)`
`Collection<Reference>` | `getReferences(Frame frame)`
`Collection` | `getReferences(Object object, int maxRefs)`
`Slot` | `getReifedRelationFromSlot()`
`Slot` | `getReifedRelationToSlot()`
`Cls` | `getReifiedRelationCls()`
`Cls` | `getRootCls()`
`Collection` | `getRootClses()`
`Cls` | `getRootClsMetaCls()`
`Cls` | `getRootFacetMetaCls()`
`Cls` | `getRootSlotMetaCls()`
`Collection` | `getRootSlots()`
`SimpleInstance` | `getSimpleInstance(String name)`
`int` | `getSimpleInstanceCount()`
`Slot` | `getSlot(String name)`
`int` | `getSlotCount()`
`Collection<Slot>` | `getSlots()`
`String` | `getSlotValueLastModificationTimestamp(Frame frame, Slot slot, boolean isTemplate)` Deprecated. this functionality is no longer available
`String` | `getSlotValueLastModifier(Frame frame, Slot slot, boolean isTemplate)` Deprecated. this functionality is no longer available
`Collection` | `getSubclasses(Cls cls)`
`Collection` | `getSubslots(Slot slot)`
`Collection` | `getSuperclasses(Cls cls)`
`Collection` | `getSuperslots(Slot slot)`
`SystemFrames` | `getSystemFrames()`
`Collection` | `getTemplateFacets(Cls cls, Slot slot)`
`Object` | `getTemplateFacetValue(Cls cls, Slot slot, Facet facet)`
`Collection` | `getTemplateFacetValues(Cls cls, Slot slot, Facet facet)`
`Collection` | `getTemplateSlotAllowedClses(Cls cls, Slot slot)`
`Collection` | `getTemplateSlotAllowedParents(Cls cls, Slot slot)`
`Collection` | `getTemplateSlotAllowedValues(Cls cls, Slot slot)`
`boolean` | `getTemplateSlotAllowsMultipleValues(Cls cls, Slot slot)`
`Collection` | `getTemplateSlotDefaultValues(Cls cls, Slot slot)`
`Collection` | `getTemplateSlotDocumentation(Cls cls, Slot slot)`
`int` | `getTemplateSlotMaximumCardinality(Cls cls, Slot slot)`
`Integer` | `getTemplateSlotMaximumCardinality2(Cls cls, Slot slot)`
`Number` | `getTemplateSlotMaximumValue(Cls cls, Slot slot)`
`int` | `getTemplateSlotMinimumCardinality(Cls cls, Slot slot)`
`Integer` | `getTemplateSlotMinimumCardinality2(Cls cls, Slot slot)`
`Number` | `getTemplateSlotMinimumValue(Cls cls, Slot slot)`
`Collection` | `getTemplateSlots(Cls cls)`
`Object` | `getTemplateSlotValue(Cls cls, Slot slot)`
`Collection` | `getTemplateSlotValues(Cls cls, Slot slot)`
`ValueType` | `getTemplateSlotValueType(Cls cls, Slot slot)`
`FrameStore` | `getTerminalFrameStore()`
`Collection` | `getTypes(Instance instance)`
`Collection` | `getUnreachableSimpleInstances(Collection rootInstances)`
`String` | `getUserName()`
`boolean` | `getValueChecking()` Deprecated. Use #getFacetCheckingEnabled
`Collection` | `getValues(Slot slot)`
`ValueType` | `getValueType(Slot slot)`
`String` | `getVersionString()`
`boolean` | `hasChanged()`
`boolean` | `hasDirectlyOverriddenTemplateFacet(Cls cls, Slot slot, Facet facet)`
`boolean` | `hasDirectlyOverriddenTemplateSlot(Cls cls, Slot slot)`
`boolean` | `hasDirectSuperclass(Cls cls, Cls superclass)`
`boolean` | `hasDirectSuperslot(Slot slot, Slot superslot)`
`boolean` | `hasDirectTemplateSlot(Cls cls, Slot slot)`
`boolean` | `hasDirectType(Instance instance, Cls cls)`
`boolean` | `hasInheritedTemplateSlot(Cls cls, Slot slot)`
`boolean` | `hasOverriddenTemplateFacet(Cls cls, Slot slot, Facet facet)`
`boolean` | `hasOverriddenTemplateSlot(Cls cls, Slot slot)`
`boolean` | `hasOwnSlot(Frame frame, Slot slot)`
`boolean` | `hasSlotValueAtSomeFrame(Slot slot)` TODO implement or deprecate hasSlotValueAtSomeFrame
`boolean` | `hasSuperclass(Cls cls, Cls superclass)`
`boolean` | `hasSuperslot(Slot slot, Slot superslot)`
`boolean` | `hasTemplateSlot(Cls cls, Slot slot)`
`boolean` | `hasType(Instance instance, Cls cls)`
`void` | `insertFrameStore(FrameStore newFrameStore)` Inserts a new frame store into the front of the delegation chain.
`void` | `insertFrameStore(FrameStore newFrameStore, int position)` Inserts a new frame store into the delegation chain.
`boolean` | `isAbstract(Cls cls)`
`boolean` | `isAutoUpdatingFacetValues()` TODO implement or deprecate isAutoUpdatingFacetValues
`boolean` | `isCallCachingEnabled()`
`boolean` | `isClosed()`
`boolean` | `isClsMetaCls(Cls cls)`
`boolean` | `isDefaultClsMetaCls(Cls cls)`
`boolean` | `isDefaultFacetMetaCls(Cls cls)`
`boolean` | `isDefaultSlotMetaCls(Cls cls)`
`boolean` | `isFacetMetaCls(Cls cls)`
`boolean` | `isJournalingEnabled()`
`boolean` | `isLoading()` TODO implement or deprecate isLoading
`boolean` | `isMetaCls(Cls cls)`
`boolean` | `isSlotMetaCls(Cls cls)`
`boolean` | `isUndoEnabled()`
`boolean` | `isValidFrameName(String name, Frame frame)`
`boolean` | `isValidOwnSlotValue(Frame frame, Slot slot, Object value)`
`void` | `moveDirectOwnSlotValue(Frame frame, Slot slot, int from, int to)`
`void` | `moveDirectSubclass(Cls cls, Cls subclass, Cls afterclass)`
`void` | `moveDirectSubclass(Cls cls, Cls subclass, int index)`
`void` | `moveDirectSubslot(Slot slot, Slot subslot, int index)`
`void` | `moveDirectSubslot(Slot slot, Slot subslot, Slot afterslot)`
`void` | `moveDirectTemplateSlot(Cls cls, Slot slot, int toIndex)`
`void` | `moveDirectType(Instance instance, Cls directType, int index)`
`void` | `notifyVisibilityChanged(Frame frame)` TODO implement notifyVisibilityChanged
`void` | `removeClsListener(Cls cls, ClsListener listener)`
`void` | `removeClsListener(ClsListener listener)`
`void` | `removeDirectSuperclass(Cls cls, Cls superclass)`
`void` | `removeDirectSuperslot(Slot slot, Slot superslot)`
`void` | `removeDirectTemplateFacetOverrides(Cls cls, Slot slot)`
`void` | `removeDirectTemplateSlot(Cls cls, Slot slot)`
`void` | `removeDirectType(Instance instance, Cls directType)`
`void` | `removeDirectTypes(Instance instance, Collection types)`
`void` | `removeFacetListener(Facet facet, FacetListener listener)`
`void` | `removeFacetListener(FacetListener listener)`
`void` | `removeFrameListener(Frame frame, FrameListener listener)`
`void` | `removeFrameListener(FrameListener listener)`
`void` | `removeFrameStore(FrameStore frameStore)`
`void` | `removeInstanceListener(Instance instance, InstanceListener listener)`
`void` | `removeInstanceListener(InstanceListener listener)`
`void` | `removeJavaLoadPackage(String packageName)`
`void` | `removeKnowledgeBaseListener(KnowledgeBaseListener listener)`
`void` | `removeOwnSlotValue(Frame frame, Slot slot, Object value)` Deprecated. use #setDirectOwnSlotValues
`void` | `removeServerProjectListener(ServerProjectListener listener)`
`void` | `removeSlotListener(SlotListener listener)`
`void` | `removeSlotListener(Slot slot, SlotListener listener)`
`void` | `removeTemplateFacetOverrides(Cls cls, Slot slot)` Deprecated. renamed to #removeDirectTemplateFacetOverrides
`void` | `removeTransactionListener(TransactionListener listener)`
`Frame` | `rename(Frame frame, String name)`
`boolean` | `rollbackTransaction()` Rolls back the recently opened transaction
`void` | `setAbstract(Cls cls, boolean isAbstract)`
`void` | `setAllowedClses(Slot slot, Collection clses)`
`void` | `setAllowedParents(Slot slot, Collection parents)`
`void` | `setAllowedValues(Slot slot, Collection values)`
`void` | `setAllowsMultipleValues(Slot slot, boolean allowsMultiple)`
`boolean` | `setArgumentCheckingEnabled(boolean b)`
`void` | `setAssociatedFacet(Slot slot, Facet facet)`
`void` | `setAssociatedSlot(Facet facet, Slot slot)`
`void` | `setAutoUpdateFacetValues(boolean autoUpdate)` Deprecated. Use setModificationRecordUpdatingEnabled
`void` | `setBuildString(String buildString)`
`void` | `setCacheMachine(ServerCacheStateMachine machine)`
`boolean` | `setCallCachingEnabled(boolean b)`
`void` | `setChanged(boolean changed)`
`boolean` | `setChangeMonitorEnabled(boolean b)`
`boolean` | `setCleanDispatchEnabled(boolean b)`
`Object` | `setClientInformation(Object key, Object value)`
`void` | `setDefaultClsMetaCls(Cls cls)`
`void` | `setDefaultFacetMetaCls(Cls cls)`
`void` | `setDefaultSlotMetaCls(Cls cls)`
`void` | `setDefaultValues(Slot slot, Collection values)`
`void` | `setDirectBrowserSlot(Cls cls, Slot slot)` Deprecated.
`void` | `setDirectBrowserSlotPattern(Cls cls, BrowserSlotPattern slotPattern)`
`void` | `setDirectBrowserTextPattern(Cls cls, BrowserSlotPattern pattern)`
`void` | `setDirectOwnSlotValue(Frame frame, Slot slot, Object value)`
`void` | `setDirectOwnSlotValues(Frame frame, Slot slot, Collection values)`
`void` | `setDirectTemplateFacetValue(Cls cls, Slot slot, Facet facet, Object value)`
`void` | `setDirectTemplateFacetValues(Cls cls, Slot slot, Facet facet, Collection values)`
`void` | `setDirectTemplateSlotValues(Cls cls, Slot slot, Collection values)`
`Instance` | `setDirectType(Instance instance, Cls type)` TODO setDirectType should return void
`void` | `setDirectTypeOfSubclasses(Cls cls, Cls type)`
`void` | `setDirectTypeOfSubslots(Slot slot, Cls type)` TODO do we need this?
`Instance` | `setDirectTypes(Instance instance, Collection newTypes)`
`boolean` | `setDispatchEventsEnabled(boolean b)`
`void` | `setDocumentation(Frame frame, Collection text)`
`void` | `setDocumentation(Frame frame, String text)`
`boolean` | `setEventDispatchEnabled(boolean b)`
`boolean` | `setEventsEnabled(boolean b)` Deprecated. Use #setGenerateEventsEnabled(boolean)
`boolean` | `setFacetCheckingEnabled(boolean enabled)`
`void` | `setFrameFactory(FrameFactory factory)`
`void` | `setFrameNamePrefix(String prefix)`
`void` | `setFrameNameValidator(FrameNameValidator validator)`
`boolean` | `setGenerateDeletingFrameEventsEnabled(boolean enabled)`
`boolean` | `setGenerateEventsEnabled(boolean b)`
`void` | `setInverseSlot(Slot slot, Slot inverseSlot)`
`boolean` | `setJournalingEnabled(boolean b)`
`void` | `setLoading(boolean loading)` TODO implement or deprecate setLoading
`void` | `setMaximumCardinality(Slot slot, int max)`
`void` | `setMaximumValue(Slot slot, Number max)`
`void` | `setMinimumCardinality(Slot slot, int min)`
`void` | `setMinimumValue(Slot slot, Number min)`
`boolean` | `setModificationRecordUpdatingEnabled(boolean enabled)`
`void` | `setName(String name)`
`void` | `setNextFrameNumber(int number)` Deprecated. This functionality is no longer available
`void` | `setOwnSlotValue(Frame frame, Slot slot, Object value)` Deprecated. renamed to #setDirectOwnSlotValue
`void` | `setOwnSlotValues(Frame frame, Slot slot, Collection values)` Deprecated. renamed to setDirectOwnSlotValues
`void` | `setPollForEvents(boolean b)`
`void` | `setProject(Project project)`
`void` | `setTemplateFacetValue(Cls cls, Slot slot, Facet facet, Object value)` Deprecated. renamed to #setDirectTemplateFacetValue
`void` | `setTemplateFacetValues(Cls cls, Slot slot, Facet facet, Collection values)` Deprecated. renamed to #setDirectTemplateFacetValues
`void` | `setTemplateSlotAllowedClses(Cls cls, Slot slot, Collection values)`
`void` | `setTemplateSlotAllowedParents(Cls cls, Slot slot, Collection values)`
`void` | `setTemplateSlotAllowedValues(Cls cls, Slot slot, Collection values)`
`void` | `setTemplateSlotAllowsMultipleValues(Cls cls, Slot slot, boolean allowsMultiple)`
`void` | `setTemplateSlotDefaultValues(Cls cls, Slot slot, Collection values)`
`void` | `setTemplateSlotDocumentation(Cls cls, Slot slot, Collection docs)`
`void` | `setTemplateSlotDocumentation(Cls cls, Slot slot, String doc)`
`void` | `setTemplateSlotMaximumCardinality(Cls cls, Slot slot, int value)`
`void` | `setTemplateSlotMaximumValue(Cls cls, Slot slot, Number value)`
`void` | `setTemplateSlotMinimumCardinality(Cls cls, Slot slot, int value)`
`void` | `setTemplateSlotMinimumValue(Cls cls, Slot slot, Number value)`
`void` | `setTemplateSlotValue(Cls cls, Slot slot, Object value)`
`void` | `setTemplateSlotValues(Cls cls, Slot slot, Collection values)` Deprecated. renamed to #setDirectTemplateSlotValues
`void` | `setTemplateSlotValueType(Cls cls, Slot slot, ValueType type)`
`void` | `setTerminalFrameStore(FrameStore store)`
`boolean` | `setUndoEnabled(boolean b)`
`void` | `setUserName(String userName)`
`void` | `setValueChecking(boolean checking)` Deprecated. Use #setFacetCheckingEnabled(boolean)
`void` | `setValues(Slot slot, Collection values)`
`void` | `setValueType(Slot slot, ValueType newType)`
`void` | `setVersionString(String versionString)`
`void` | `startJournaling(URI journal)`
`void` | `stopJournaling()`
`String` | `toString()`
`protected String` | `toString(BrowserSlotPattern pattern)`
`protected String` | `toString(Object o)`
`protected String` | `toStringForFrame(Frame frame)`
`protected String` | `toStringForObject(Object o)`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### SERVER_PROCESS_USER

    public static final String SERVER_PROCESS_USER

See Also:
  Constant Field Values

Constructor Detail

### DefaultKnowledgeBase

    public DefaultKnowledgeBase(KnowledgeBaseFactory factory)

### DefaultKnowledgeBase

    public DefaultKnowledgeBase()

Method Detail

### createSystemFrames

    protected SystemFrames createSystemFrames()

### createFrameFactory

    protected FrameFactory createFrameFactory()

### createFrameStoreManager

    protected FrameStoreManager createFrameStoreManager()

### getFrameStoreManager

    public FrameStoreManager getFrameStoreManager()

  Specified by:
    `getFrameStoreManager` in interface `KnowledgeBase`

### getHeadFrameStore

    public FrameStore getHeadFrameStore()

### getSystemFrames

    public SystemFrames getSystemFrames()

  Specified by:
    `getSystemFrames` in interface `KnowledgeBase`

### getFrameFactory

    public FrameFactory getFrameFactory()

  Specified by:
    `getFrameFactory` in interface `KnowledgeBase`

### close

    public void close()

### setCleanDispatchEnabled

    public boolean setCleanDispatchEnabled(boolean b)

  Specified by:
    `setCleanDispatchEnabled` in interface `KnowledgeBase`

### setArgumentCheckingEnabled

    public boolean setArgumentCheckingEnabled(boolean b)

  Specified by:
    `setArgumentCheckingEnabled` in interface `KnowledgeBase`

### isJournalingEnabled

    public boolean isJournalingEnabled()

  Specified by:
    `isJournalingEnabled` in interface `KnowledgeBase`

### isCallCachingEnabled

    public boolean isCallCachingEnabled()

  Specified by:
    `isCallCachingEnabled` in interface `KnowledgeBase`

### setJournalingEnabled

    public boolean setJournalingEnabled(boolean b)

  Specified by:
    `setJournalingEnabled` in interface `KnowledgeBase`

### setUndoEnabled

    public boolean setUndoEnabled(boolean b)

  Specified by:
    `setUndoEnabled` in interface `KnowledgeBase`

### setEventDispatchEnabled

    public boolean setEventDispatchEnabled(boolean b)

### setCallCachingEnabled

    public boolean setCallCachingEnabled(boolean b)

  Specified by:
    `setCallCachingEnabled` in interface `KnowledgeBase`

### setGenerateEventsEnabled

    public boolean setGenerateEventsEnabled(boolean b)

  Specified by:
    `setGenerateEventsEnabled` in interface `KnowledgeBase`

### isUndoEnabled

    public boolean isUndoEnabled()

  Specified by:
    `isUndoEnabled` in interface `KnowledgeBase`

### flushEvents

    public void flushEvents()
                     throws ProtegeException

  Specified by:
    `flushEvents` in interface `KnowledgeBase`
  Throws:
    `ProtegeException`

### getDirectOwnSlotValues

    public List getDirectOwnSlotValues(Frame frame,
                                       Slot slot)

  Specified by:
    `getDirectOwnSlotValues` in interface `KnowledgeBase`

### createCls

    public Cls createCls(String name,
                         Collection directSuperclasses,
                         Collection directTypes,
                         boolean loadDefaults)

### createCls

    public Cls createCls(FrameID id,
                         Collection directSuperclasses,
                         Collection directTypes,
                         boolean loadDefaults)

  Specified by:
    `createCls` in interface `KnowledgeBase`
  Parameters:
    `id` - Pass null to cause the system to generate an id

### createSlot

    public Slot createSlot(String name,
                           Cls directType,
                           Collection superslots,
                           boolean loadDefaults)

  Specified by:
    `createSlot` in interface `KnowledgeBase`
  Parameters:
    `name` - Pass null to cause the system to generate a name

### createSlot

    public Slot createSlot(FrameID id,
                           Collection directTypes,
                           Collection superslots,
                           boolean loadDefaults)

### createSimpleInstance

    public SimpleInstance createSimpleInstance(String name,
                                               Cls directType,
                                               boolean loadDefaults)

### createSimpleInstance

    public SimpleInstance createSimpleInstance(FrameID id,
                                               Collection types,
                                               boolean loadDefaults)

  Specified by:
    `createSimpleInstance` in interface `KnowledgeBase`
  Parameters:
    `id` - Pass null to cause the system to generate an id

### createSimpleInstance

    public SimpleInstance createSimpleInstance(FrameID id,
                                               Cls directType,
                                               boolean loadDefaults)

### setDirectOwnSlotValues

    public void setDirectOwnSlotValues(Frame frame,
                                       Slot slot,
                                       Collection values)

  Specified by:
    `setDirectOwnSlotValues` in interface `KnowledgeBase`

### getFrame

    public Frame getFrame(FrameID id)

  Specified by:
    `getFrame` in interface `KnowledgeBase`

### getFrame

    public Frame getFrame(String name)

  Specified by:
    `getFrame` in interface `KnowledgeBase`

### getOwnSlotValues

    public Collection getOwnSlotValues(Frame frame,
                                       Slot slot)

  Specified by:
    `getOwnSlotValues` in interface `KnowledgeBase`

### getDirectOwnSlotValue

    public Object getDirectOwnSlotValue(Frame frame,
                                        Slot slot)

  Specified by:
    `getDirectOwnSlotValue` in interface `KnowledgeBase`

### getOwnSlots

    public Collection<Slot> getOwnSlots(Frame frame)

  Specified by:
    `getOwnSlots` in interface `KnowledgeBase`

### getTemplateSlots

    public Collection getTemplateSlots(Cls cls)

  Specified by:
    `getTemplateSlots` in interface `KnowledgeBase`

### getReferences

    public Collection<Reference> getReferences(Frame frame)

### deleteFrame

    public void deleteFrame(Frame frame)

  Specified by:
    `deleteFrame` in interface `KnowledgeBase`

### setEventsEnabled

    @Deprecated
    public boolean setEventsEnabled(boolean b)

  Deprecated. Use #setGenerateEventsEnabled(boolean)

  Specified by:
    `setEventsEnabled` in interface `KnowledgeBase`

### getEventsEnabled

    @Deprecated
    public boolean getEventsEnabled()

  Deprecated. Use #getGenerateEventsEnabled(boolean)

  Specified by:
    `getEventsEnabled` in interface `KnowledgeBase`

### getGenerateEventsEnabled

    public boolean getGenerateEventsEnabled()

  Specified by:
    `getGenerateEventsEnabled` in interface `KnowledgeBase`

### getDispatchEventsEnabled

    public boolean getDispatchEventsEnabled()

  Specified by:
    `getDispatchEventsEnabled` in interface `KnowledgeBase`

### setDispatchEventsEnabled

    public boolean setDispatchEventsEnabled(boolean b)

  Specified by:
    `setDispatchEventsEnabled` in interface `KnowledgeBase`

### setChangeMonitorEnabled

    public boolean setChangeMonitorEnabled(boolean b)

  Specified by:
    `setChangeMonitorEnabled` in interface `KnowledgeBase`

### getDirectType

    public Cls getDirectType(Instance instance)

  Specified by:
    `getDirectType` in interface `KnowledgeBase`

### getDirectSuperclasses

    public Collection<Cls> getDirectSuperclasses(Cls cls)

  Specified by:
    `getDirectSuperclasses` in interface `KnowledgeBase`

### getName

    public String getName(Frame frame)

  Specified by:
    `getName` in interface `KnowledgeBase`

### addJavaLoadPackage

    public void addJavaLoadPackage(String packageName)

  Description copied from interface: `KnowledgeBase`
  This method requires some background information. When Protege wants to create a simple instance in the kb it creates an instance of the java class "DefaultSimpleInstance". Programmers can subclass this class and give the subclass the name of a class in the kb. Then when protege wants to create an instance of the class in the kb it will instead make an instance of the programmers java class rather than DefaultSimpleInstance. In order for this to work the user must specify the package that their java class appears in. (The class file must also be in the plugins directory.) For example, consider a protege project with a class A. Now a programmer creates a subclass of model.DefaultSimpleInstance and calls it org.me.A. He puts this .class file in the plugins/org/me directory. (Presumably he creates the subclass this in order to add additional methods onto org.me.A to provide some sort of desired functionality. The desired behavior is that when the user creates an instance of the kb class A that the system will create an instance of org.me.A and put it in the kb. Then when the programmer queries the kb for "get me instances of A" he will get back instances which can be cast to org.me.A. So, what this method does is to tell the system what package to search to find the java class to create. When the system creates an instance of A it searches all the packages, in order, to find a java class with the name .A. If it finds one then it uses it to create an instance. If it doesn't find any matches then it creates an instance of DefaultSimpleInstance.

  Specified by:
    `addJavaLoadPackage` in interface `KnowledgeBase`

### areValidOwnSlotValues

    public boolean areValidOwnSlotValues(Frame frame,
                                         Slot slot,
                                         Collection values)

  Specified by:
    `areValidOwnSlotValues` in interface `KnowledgeBase`

### containsFrame

    public boolean containsFrame(String name)

  Specified by:
    `containsFrame` in interface `KnowledgeBase`

### createCls

    public Cls createCls(String name,
                         Collection superclasses)

  Specified by:
    `createCls` in interface `KnowledgeBase`
  Parameters:
    `name` - Pass null to cause the system to generate a name

### createCls

    public Cls createCls(String name,
                         Collection superclasses,
                         Cls directType)

  Specified by:
    `createCls` in interface `KnowledgeBase`
  Parameters:
    `name` - Pass null to cause the system to generate a name

### createCls

    public Cls createCls(String name,
                         Collection superclasses,
                         Cls directType,
                         boolean initializeDefaults)

  Specified by:
    `createCls` in interface `KnowledgeBase`
  Parameters:
    `name` - Pass null to cause the system to generate a name

### createFacet

    public Facet createFacet(String name)

  Specified by:
    `createFacet` in interface `KnowledgeBase`
  Parameters:
    `name` - Pass null to cause the system to generate a name

### createFacet

    public Facet createFacet(String name,
                             Cls directType)

  Specified by:
    `createFacet` in interface `KnowledgeBase`
  Parameters:
    `name` - Pass null to cause the system to generate a name

### createFacet

    public Facet createFacet(String name,
                             Cls directType,
                             boolean initializeDefaults)

  Specified by:
    `createFacet` in interface `KnowledgeBase`
  Parameters:
    `name` - Pass null to cause the system to generate a name

### createFacet

    public Facet createFacet(FrameID id,
                             Collection directTypes,
                             boolean initializeDefaults)

### createInstance

    public Instance createInstance(String name,
                                   Cls directType)

  Specified by:
    `createInstance` in interface `KnowledgeBase`
  Parameters:
    `name` - Pass null to cause the system to generate a name

### createInstance

    public Instance createInstance(String name,
                                   Collection directTypes)

  Specified by:
    `createInstance` in interface `KnowledgeBase`
  Parameters:
    `name` - Pass null to cause the system to generate a name

### createInstance

    public Instance createInstance(String name,
                                   Cls directType,
                                   boolean initializeDefaults)

  Specified by:
    `createInstance` in interface `KnowledgeBase`
  Parameters:
    `name` - Pass null to cause the system to generate a name

### createInstance

    public Instance createInstance(FrameID id,
                                   Cls directType,
                                   boolean initializeDefaults)

  Specified by:
    `createInstance` in interface `KnowledgeBase`
  Parameters:
    `id` - Pass null to cause the system to generate an id

### createInstance

    public Instance createInstance(FrameID id,
                                   Collection directTypes,
                                   boolean initializeDefaults)

  Specified by:
    `createInstance` in interface `KnowledgeBase`
  Parameters:
    `id` - Pass null to cause the system to generate an id

### createSlot

    public Slot createSlot(String name)

  Specified by:
    `createSlot` in interface `KnowledgeBase`
  Parameters:
    `name` - Pass null to cause the system to generate a name

### createSlot

    public Slot createSlot(String name,
                           Cls directType)

  Specified by:
    `createSlot` in interface `KnowledgeBase`
  Parameters:
    `name` - Pass null to cause the system to generate a name

### createSlot

    public Slot createSlot(String name,
                           Cls directType,
                           boolean loadDefaults)

  Specified by:
    `createSlot` in interface `KnowledgeBase`
  Parameters:
    `name` - Pass null to cause the system to generate a name

### createUniqueFrameName

    @Deprecated
    public String createUniqueFrameName(String name)

  Deprecated. no longer needed

  Specified by:
    `createUniqueFrameName` in interface `KnowledgeBase`

### deleteCls

    public void deleteCls(Cls cls)

  Specified by:
    `deleteCls` in interface `KnowledgeBase`

### deleteFacet

    public void deleteFacet(Facet facet)

  Specified by:
    `deleteFacet` in interface `KnowledgeBase`

### deleteInstance

    public void deleteInstance(Instance instance)

  Specified by:
    `deleteInstance` in interface `KnowledgeBase`

### deleteSimpleInstance

    public void deleteSimpleInstance(SimpleInstance simpleInstance)

### deleteSlot

    public void deleteSlot(Slot slot)

  Specified by:
    `deleteSlot` in interface `KnowledgeBase`

### getBuildString

    public String getBuildString()

  Description copied from interface: `KnowledgeBase`
  Returns a string that contains something like "build 840" that refers to the build of Protege in use when this kb was last saved. This string format is not reliable and may change.

  Specified by:
    `getBuildString` in interface `KnowledgeBase`

### getClientInformation

    public Object getClientInformation(Object key)

  Description copied from interface: `KnowledgeBase`
  Allows a programmer to hang arbitrary information on a kb and retrieve it later. This information is not persistent. Since all programmers share the same "client information space" we recommend that your "key" be your java.lang.Class object. If you want to store more than one piece of information then you can make your value a set (or a map). Thus the common usage would be:

             Map myGoodStuff = new HashMap();
             myGoodStuff.put("foo", "bar");
             kb.setClientInformation(myClass.class, myGoodStuff);
             // ... later
             Map myGoodStuff = (Map) kb.getClientInformation(myClass.class);

  Widget writers typically don't need this sort of thing but backend authors do because one instance of the backend may need to communicate information to another instance (the loader to the storer, for example). This is very similar to the "client property" feature on javax.swing.JComponent or the client information on MS Windows windows and it exists for the same reasons. It allows you to store anything you want.

  Specified by:
    `getClientInformation` in interface `KnowledgeBase`

### getCls

    public Cls getCls(String name)

  Specified by:
    `getCls` in interface `KnowledgeBase`

### getClsCount

    public int getClsCount()

  Specified by:
    `getClsCount` in interface `KnowledgeBase`

### getSimpleInstanceCount

    public int getSimpleInstanceCount()

  Specified by:
    `getSimpleInstanceCount` in interface `KnowledgeBase`

### getClses

    public Collection<Cls> getClses()

  Specified by:
    `getClses` in interface `KnowledgeBase`

### getClsNameMatches

    public Collection getClsNameMatches(String name,
                                        int maxMatches)

  Description copied from interface: `KnowledgeBase`
  Get classes whose name matches the give string. This string allows "*" for "match any sequence" of characters. The string is not a regular expression. The matching is case-insensitive.

  Specified by:
    `getClsNameMatches` in interface `KnowledgeBase`

### getDefaultClsMetaCls

    public Cls getDefaultClsMetaCls()

  Description copied from interface: `KnowledgeBase`
  If no meta class is specified when a class is created the system uses the metaclass of the first specified parent. If no parent is specified, or if the parent is :THING then the system uses this metaclass.

  Specified by:
    `getDefaultClsMetaCls` in interface `KnowledgeBase`

### getDefaultFacetMetaCls

    public Cls getDefaultFacetMetaCls()

  Specified by:
    `getDefaultFacetMetaCls` in interface `KnowledgeBase`

### getDefaultSlotMetaCls

    public Cls getDefaultSlotMetaCls()

  Specified by:
    `getDefaultSlotMetaCls` in interface `KnowledgeBase`

### getFacet

    public Facet getFacet(String name)

  Specified by:
    `getFacet` in interface `KnowledgeBase`

### getFacetCount

    public int getFacetCount()

  Specified by:
    `getFacetCount` in interface `KnowledgeBase`

### getFacets

    public Collection getFacets()

  Specified by:
    `getFacets` in interface `KnowledgeBase`

### getFrameCount

    public int getFrameCount()

  Specified by:
    `getFrameCount` in interface `KnowledgeBase`

### getFrameCreationTimestamp

    public String getFrameCreationTimestamp(Frame frame)

  Specified by:
    `getFrameCreationTimestamp` in interface `KnowledgeBase`

### getFrameCreator

    public String getFrameCreator(Frame frame)

  Specified by:
    `getFrameCreator` in interface `KnowledgeBase`

### getFrameLastModificationTimestamp

    public String getFrameLastModificationTimestamp(Frame frame)

  Specified by:
    `getFrameLastModificationTimestamp` in interface `KnowledgeBase`

### getFrameLastModifier

    public String getFrameLastModifier(Frame frame)

  Specified by:
    `getFrameLastModifier` in interface `KnowledgeBase`

### getFrameNameMatches

    public Collection<Frame> getFrameNameMatches(String name,
                                                 int maxMatches)

  Specified by:
    `getFrameNameMatches` in interface `KnowledgeBase`

### getFramesWithValue

    public Collection getFramesWithValue(Slot slot,
                                         Facet facet,
                                         boolean isTemplate,
                                         Object value)

  Description copied from interface: `KnowledgeBase`
  Gets frames with a particular own/template slot/facet value.

  Specified by:
    `getFramesWithValue` in interface `KnowledgeBase`
  Parameters:
    `slot` - The slot to use. Must not be null.
    `facet` - If null then the value parameter is a slot value. Otherwise it is a facet value.
    `isTemplate` - If true then the return value is a template slot/facet value.
    `value` - A value to match exactly. The type of the object can be one of those listed in the documentation for `Frame`
  Returns:
    Collection of frames.

### getFramesWithMatchingDirectOwnSlotValue

    public Set getFramesWithMatchingDirectOwnSlotValue(Slot slot,
                                                       String value,
                                                       int maxMatches)

### getFrameNamePrefix

    public String getFrameNamePrefix()

  Specified by:
    `getFrameNamePrefix` in interface `KnowledgeBase`

### getFrames

    public Collection getFrames()

  Specified by:
    `getFrames` in interface `KnowledgeBase`

### getInstance

    public Instance getInstance(String name)

  Specified by:
    `getInstance` in interface `KnowledgeBase`

### getSimpleInstance

    public SimpleInstance getSimpleInstance(String name)

  Specified by:
    `getSimpleInstance` in interface `KnowledgeBase`

### getInstances

    public Collection<Instance> getInstances()

  Specified by:
    `getInstances` in interface `KnowledgeBase`

### getInstances

    @Deprecated
    public Collection<Instance> getInstances(Cls cls)

  Deprecated.

  Specified by:
    `getInstances` in interface `KnowledgeBase`

### getInvalidOwnSlotValuesText

    public String getInvalidOwnSlotValuesText(Frame frame,
                                              Slot slot,
                                              Collection values)

  Specified by:
    `getInvalidOwnSlotValuesText` in interface `KnowledgeBase`

### getInvalidOwnSlotValueText

    public String getInvalidOwnSlotValueText(Frame frame,
                                             Slot slot,
                                             Object value)

  Specified by:
    `getInvalidOwnSlotValueText` in interface `KnowledgeBase`

### getKnowledgeBaseFactory

    public KnowledgeBaseFactory getKnowledgeBaseFactory()

  Specified by:
    `getKnowledgeBaseFactory` in interface `KnowledgeBase`

### getMatchingFrames

    public Collection getMatchingFrames(Slot slot,
                                        Facet facet,
                                        boolean isTemplate,
                                        String value,
                                        int maxMatches)

  Description copied from interface: `KnowledgeBase`
  Finds all occurances of a string in the knowledge base. This function searches all slot/facet values for the given slot and facet and looks for string values that match matchString. A string value is said to match matchString if the string value is a match for the regular expression given by matchString. In the interests of performance, there is some leeway in what exactly is meant by a match. For the in memory backends, the match is calculated using the java.util.regex.Pattern algorithm except that any occurance "*" in the matchString is replaced with ".*" (e.g. "*" matches anything). However, database backends use a variation of the database LIKE operator except that "*" (match everything in the getMatching frames sense) is mapped to "%" (match everything in the database sense).

  Specified by:
    `getMatchingFrames` in interface `KnowledgeBase`
  Parameters:
    `slot` - The slot to use. Must not be null.
    `facet` - If null then the matchString parameter is a slot value. Otherwise it is a facet value.
    `isTemplate` - If true then the return value is a template slot/facet value.
    `value` - The string to match on. The string can include wild cards. The matching is case insensitive.
    `maxMatches` - maximum number of matches. Use -1 to get all matches. Be careful though. If the use searches on "e" do you really want to return 1M frames?
  Returns:
    Collection of frames.

### getName

    public String getName()

  Specified by:
    `getName` in interface `KnowledgeBase`

### getNextFrameNumber

    @Deprecated
    public int getNextFrameNumber()

  Deprecated. No longer implemented

  Specified by:
    `getNextFrameNumber` in interface `KnowledgeBase`

### getProject

    public Project getProject()

  Specified by:
    `getProject` in interface `KnowledgeBase`

### getReachableSimpleInstances

    public Collection getReachableSimpleInstances(Collection rootInstances)

  Specified by:
    `getReachableSimpleInstances` in interface `KnowledgeBase`

### getReferences

    public Collection getReferences(Object object,
                                    int maxRefs)

  Specified by:
    `getReferences` in interface `KnowledgeBase`
  Returns:
    A collection of #Reference instances.

### getMatchingReferences

    public Collection<Reference> getMatchingReferences(String s,
                                                       int maxRefs)

  Specified by:
    `getMatchingReferences` in interface `KnowledgeBase`

### getClsesWithMatchingBrowserText

    public Collection<Cls> getClsesWithMatchingBrowserText(String s,
                                                           Collection superclasses,
                                                           int maxMatches)

  Specified by:
    `getClsesWithMatchingBrowserText` in interface `KnowledgeBase`

### getRootCls

    public Cls getRootCls()

  Specified by:
    `getRootCls` in interface `KnowledgeBase`

### getRootClses

    public Collection getRootClses()

  Specified by:
    `getRootClses` in interface `KnowledgeBase`
  Returns:
    ":THING" wrapped in a collection. A convenience method.

### getRootClsMetaCls

    public Cls getRootClsMetaCls()

  Specified by:
    `getRootClsMetaCls` in interface `KnowledgeBase`

### getRootFacetMetaCls

    public Cls getRootFacetMetaCls()

  Specified by:
    `getRootFacetMetaCls` in interface `KnowledgeBase`

### getRootSlotMetaCls

    public Cls getRootSlotMetaCls()

  Specified by:
    `getRootSlotMetaCls` in interface `KnowledgeBase`

### getRootSlots

    public Collection getRootSlots()

  Specified by:
    `getRootSlots` in interface `KnowledgeBase`

### getSlot

    public Slot getSlot(String name)

  Specified by:
    `getSlot` in interface `KnowledgeBase`

### getSlotCount

    public int getSlotCount()

  Specified by:
    `getSlotCount` in interface `KnowledgeBase`

### getSlots

    public Collection<Slot> getSlots()

  Specified by:
    `getSlots` in interface `KnowledgeBase`

### getSlotValueLastModificationTimestamp

    @Deprecated
    public String getSlotValueLastModificationTimestamp(Frame frame,
                                                                   Slot slot,
                                                                   boolean isTemplate)

  Deprecated. this functionality is no longer available

  Specified by:
    `getSlotValueLastModificationTimestamp` in interface `KnowledgeBase`

### getSlotValueLastModifier

    @Deprecated
    public String getSlotValueLastModifier(Frame frame,
                                                      Slot slot,
                                                      boolean isTemplate)

  Deprecated. this functionality is no longer available

  Specified by:
    `getSlotValueLastModifier` in interface `KnowledgeBase`

### getSubclasses

    public Collection getSubclasses(Cls cls)

  Specified by:
    `getSubclasses` in interface `KnowledgeBase`

### getUnreachableSimpleInstances

    public Collection getUnreachableSimpleInstances(Collection rootInstances)

  Specified by:
    `getUnreachableSimpleInstances` in interface `KnowledgeBase`

### getUserName

    public String getUserName()

  Specified by:
    `getUserName` in interface `KnowledgeBase`

### getVersionString

    public String getVersionString()

  Specified by:
    `getVersionString` in interface `KnowledgeBase`
  Returns:
    a string that contains something like "Version 1.6.2" that refers to the version of Protege in use when this kb was last saved. This string format is not reliable and may change.

### hasChanged

    public boolean hasChanged()

  Specified by:
    `hasChanged` in interface `KnowledgeBase`

### isAutoUpdatingFacetValues

    public boolean isAutoUpdatingFacetValues()

  TODO implement or deprecate isAutoUpdatingFacetValues

  Specified by:
    `isAutoUpdatingFacetValues` in interface `KnowledgeBase`

### isClsMetaCls

    public boolean isClsMetaCls(Cls cls)

  Specified by:
    `isClsMetaCls` in interface `KnowledgeBase`

### equals

    public static boolean equals(Object o1,
                                 Object o2)

### isDefaultClsMetaCls

    public boolean isDefaultClsMetaCls(Cls cls)

  Specified by:
    `isDefaultClsMetaCls` in interface `KnowledgeBase`

### isDefaultFacetMetaCls

    public boolean isDefaultFacetMetaCls(Cls cls)

  Specified by:
    `isDefaultFacetMetaCls` in interface `KnowledgeBase`

### isDefaultSlotMetaCls

    public boolean isDefaultSlotMetaCls(Cls cls)

  Specified by:
    `isDefaultSlotMetaCls` in interface `KnowledgeBase`

### isFacetMetaCls

    public boolean isFacetMetaCls(Cls cls)

  Specified by:
    `isFacetMetaCls` in interface `KnowledgeBase`

### isLoading

    public boolean isLoading()

  TODO implement or deprecate isLoading

  Specified by:
    `isLoading` in interface `KnowledgeBase`

### isSlotMetaCls

    public boolean isSlotMetaCls(Cls cls)

  Specified by:
    `isSlotMetaCls` in interface `KnowledgeBase`

### isValidOwnSlotValue

    public boolean isValidOwnSlotValue(Frame frame,
                                       Slot slot,
                                       Object value)

  Specified by:
    `isValidOwnSlotValue` in interface `KnowledgeBase`

### removeJavaLoadPackage

    public void removeJavaLoadPackage(String packageName)

  Specified by:
    `removeJavaLoadPackage` in interface `KnowledgeBase`

### setAutoUpdateFacetValues

    @Deprecated
    public void setAutoUpdateFacetValues(boolean autoUpdate)

  Deprecated. Use setModificationRecordUpdatingEnabled

  Specified by:
    `setAutoUpdateFacetValues` in interface `KnowledgeBase`

### setModificationRecordUpdatingEnabled

    public boolean setModificationRecordUpdatingEnabled(boolean enabled)

  Specified by:
    `setModificationRecordUpdatingEnabled` in interface `KnowledgeBase`

### setBuildString

    public void setBuildString(String buildString)

  Specified by:
    `setBuildString` in interface `KnowledgeBase`

### setChanged

    public void setChanged(boolean changed)

  Specified by:
    `setChanged` in interface `KnowledgeBase`

### setClientInformation

    public Object setClientInformation(Object key,
                                       Object value)

  Specified by:
    `setClientInformation` in interface `KnowledgeBase`

### setDefaultClsMetaCls

    public void setDefaultClsMetaCls(Cls cls)

  Specified by:
    `setDefaultClsMetaCls` in interface `KnowledgeBase`

### setDefaultFacetMetaCls

    public void setDefaultFacetMetaCls(Cls cls)

  Specified by:
    `setDefaultFacetMetaCls` in interface `KnowledgeBase`

### setDefaultSlotMetaCls

    public void setDefaultSlotMetaCls(Cls cls)

  Specified by:
    `setDefaultSlotMetaCls` in interface `KnowledgeBase`

### setFrameNamePrefix

    public void setFrameNamePrefix(String prefix)

  Specified by:
    `setFrameNamePrefix` in interface `KnowledgeBase`

### setLoading

    public void setLoading(boolean loading)

  TODO implement or deprecate setLoading

### setName

    public void setName(String name)

  Specified by:
    `setName` in interface `KnowledgeBase`

### setNextFrameNumber

    @Deprecated
    public void setNextFrameNumber(int number)

  Deprecated. This functionality is no longer available

  Specified by:
    `setNextFrameNumber` in interface `KnowledgeBase`

### setProject

    public void setProject(Project project)

  Specified by:
    `setProject` in interface `KnowledgeBase`

### adjustForClient

    protected void adjustForClient()

### adjustForServer

    protected void adjustForServer()

### setValueChecking

    @Deprecated
    public void setValueChecking(boolean checking)

  Deprecated. Use #setFacetCheckingEnabled(boolean)

  Description copied from interface: `KnowledgeBase`
  Checks every call that changes an own slot value that the new value is consistent with all facets. This checking is disabled by default. It can significately slow down the system but is useful for tracking down bugs in code that calls the api (both system and user code).

  Specified by:
    `setValueChecking` in interface `KnowledgeBase`

### setFacetCheckingEnabled

    public boolean setFacetCheckingEnabled(boolean enabled)

  Specified by:
    `setFacetCheckingEnabled` in interface `KnowledgeBase`

### setVersionString

    public void setVersionString(String versionString)

  Specified by:
    `setVersionString` in interface `KnowledgeBase`

### dispose

    public void dispose()

  Specified by:
    `dispose` in interface `Disposable`

### isClosed

    public boolean isClosed()

  Specified by:
    `isClosed` in interface `KnowledgeBase`

### getReachableSimpleInstances

    public Collection getReachableSimpleInstances(Frame frame)

### addOwnSlotValue

    @Deprecated
    public void addOwnSlotValue(Frame frame,
                                           Slot slot,
                                           Object value)

  Deprecated. use #addDirectOwnSlotValues

  Specified by:
    `addOwnSlotValue` in interface `KnowledgeBase`

### getDocumentation

    public Collection getDocumentation(Frame frame)

  Specified by:
    `getDocumentation` in interface `KnowledgeBase`

### getOwnSlotAllowsMultipleValues

    public boolean getOwnSlotAllowsMultipleValues(Frame frame,
                                                  Slot slot)

  Specified by:
    `getOwnSlotAllowsMultipleValues` in interface `KnowledgeBase`

### getOwnSlotAndSubslotValues

    @Deprecated
    public Collection getOwnSlotAndSubslotValues(Frame frame,
                                                            Slot slot)

  Deprecated. use getOwnSlotValues

  Specified by:
    `getOwnSlotAndSubslotValues` in interface `KnowledgeBase`

### getOwnSlotDefaultValues

    public Collection getOwnSlotDefaultValues(Frame frame,
                                              Slot slot)

  Specified by:
    `getOwnSlotDefaultValues` in interface `KnowledgeBase`

### getOwnSlotFacets

    @Deprecated
    public Collection getOwnSlotFacets(Frame frame,
                                                  Slot slot)

  Deprecated. renamed to #getOwnFacets

  Specified by:
    `getOwnSlotFacets` in interface `KnowledgeBase`

### getOwnSlotFacetValues

    @Deprecated
    public Collection getOwnSlotFacetValues(Frame frame,
                                                       Slot slot,
                                                       Facet facet)

  Deprecated. renamed to #getOwnFacetValues

  Specified by:
    `getOwnSlotFacetValues` in interface `KnowledgeBase`

### getOwnFacets

    public Collection getOwnFacets(Frame frame,
                                   Slot slot)

### getOwnFacetValues

    public Collection getOwnFacetValues(Frame frame,
                                        Slot slot,
                                        Facet facet)

### getOwnSlotValue

    public Object getOwnSlotValue(Frame frame,
                                  Slot slot)

  Specified by:
    `getOwnSlotValue` in interface `KnowledgeBase`

### getOwnSlotValueCount

    public int getOwnSlotValueCount(Frame frame,
                                    Slot slot)

  Specified by:
    `getOwnSlotValueCount` in interface `KnowledgeBase`

### getOwnSlotValueType

    public ValueType getOwnSlotValueType(Frame frame,
                                         Slot slot)

  Specified by:
    `getOwnSlotValueType` in interface `KnowledgeBase`

### hasOwnSlot

    public boolean hasOwnSlot(Frame frame,
                              Slot slot)

  Specified by:
    `hasOwnSlot` in interface `KnowledgeBase`

### moveDirectOwnSlotValue

    public void moveDirectOwnSlotValue(Frame frame,
                                       Slot slot,
                                       int from,
                                       int to)

  Specified by:
    `moveDirectOwnSlotValue` in interface `KnowledgeBase`

### removeOwnSlotValue

    @Deprecated
    public void removeOwnSlotValue(Frame frame,
                                              Slot slot,
                                              Object value)

  Deprecated. use #setDirectOwnSlotValues

  Specified by:
    `removeOwnSlotValue` in interface `KnowledgeBase`

### setDocumentation

    public void setDocumentation(Frame frame,
                                 String text)

  Specified by:
    `setDocumentation` in interface `KnowledgeBase`

### setDocumentation

    public void setDocumentation(Frame frame,
                                 Collection text)

  Specified by:
    `setDocumentation` in interface `KnowledgeBase`

### setOwnSlotValue

    @Deprecated
    public void setOwnSlotValue(Frame frame,
                                           Slot slot,
                                           Object value)

  Deprecated. renamed to #setDirectOwnSlotValue

### setDirectOwnSlotValue

    public void setDirectOwnSlotValue(Frame frame,
                                      Slot slot,
                                      Object value)

### setOwnSlotValues

    @Deprecated
    public void setOwnSlotValues(Frame frame,
                                            Slot slot,
                                            Collection values)

  Deprecated. renamed to setDirectOwnSlotValues

  Description copied from interface: `KnowledgeBase`
  same as #setDirectOwnSlotValues(Frame, Slot, Collection)

  Specified by:
    `setOwnSlotValues` in interface `KnowledgeBase`

### notifyVisibilityChanged

    public void notifyVisibilityChanged(Frame frame)

  TODO implement notifyVisibilityChanged

  Specified by:
    `notifyVisibilityChanged` in interface `KnowledgeBase`

### getAssociatedSlot

    public Slot getAssociatedSlot(Facet facet)

  Specified by:
    `getAssociatedSlot` in interface `KnowledgeBase`

### setAssociatedSlot

    public void setAssociatedSlot(Facet facet,
                                  Slot slot)

  Specified by:
    `setAssociatedSlot` in interface `KnowledgeBase`

### addDirectSuperclass

    public void addDirectSuperclass(Cls cls,
                                    Cls superclass)

  Specified by:
    `addDirectSuperclass` in interface `KnowledgeBase`

### removeDirectSuperclass

    public void removeDirectSuperclass(Cls cls,
                                       Cls superclass)

  Specified by:
    `removeDirectSuperclass` in interface `KnowledgeBase`

### addDirectType

    public void addDirectType(Instance instance,
                              Cls directType)

  Specified by:
    `addDirectType` in interface `KnowledgeBase`

### removeDirectType

    public void removeDirectType(Instance instance,
                                 Cls directType)

  Specified by:
    `removeDirectType` in interface `KnowledgeBase`

### moveDirectType

    public void moveDirectType(Instance instance,
                               Cls directType,
                               int index)

  Specified by:
    `moveDirectType` in interface `KnowledgeBase`

### addDirectTemplateSlot

    public void addDirectTemplateSlot(Cls cls,
                                      Slot slot)

  Specified by:
    `addDirectTemplateSlot` in interface `KnowledgeBase`

### removeDirectTemplateSlot

    public void removeDirectTemplateSlot(Cls cls,
                                         Slot slot)

  Specified by:
    `removeDirectTemplateSlot` in interface `KnowledgeBase`

### addTemplateFacetValue

    @Deprecated
    public void addTemplateFacetValue(Cls cls,
                                                 Slot slot,
                                                 Facet facet,
                                                 Object value)

  Deprecated. use #setDirectTemplateFacetValues

  Specified by:
    `addTemplateFacetValue` in interface `KnowledgeBase`

### addTemplateSlotValue

    @Deprecated
    public void addTemplateSlotValue(Cls cls,
                                                Slot slot,
                                                Object value)

  Deprecated. use #setDirectTemplateSlotValues

  Specified by:
    `addTemplateSlotValue` in interface `KnowledgeBase`

### getNameSlot

    public Slot getNameSlot()

  Specified by:
    `getNameSlot` in interface `KnowledgeBase`

### getDirectInstanceCount

    public int getDirectInstanceCount(Cls cls)

  Specified by:
    `getDirectInstanceCount` in interface `KnowledgeBase`

### getDirectInstances

    public Collection<Instance> getDirectInstances(Cls cls)

  Specified by:
    `getDirectInstances` in interface `KnowledgeBase`

### getDirectSubclassCount

    public int getDirectSubclassCount(Cls cls)

  Specified by:
    `getDirectSubclassCount` in interface `KnowledgeBase`

### getDirectSubclasses

    public Collection getDirectSubclasses(Cls cls)

  Specified by:
    `getDirectSubclasses` in interface `KnowledgeBase`

### getDirectSuperclassCount

    public int getDirectSuperclassCount(Cls cls)

  Specified by:
    `getDirectSuperclassCount` in interface `KnowledgeBase`

### getDirectTemplateFacetValues

    public List getDirectTemplateFacetValues(Cls cls,
                                             Slot slot,
                                             Facet facet)

  Specified by:
    `getDirectTemplateFacetValues` in interface `KnowledgeBase`

### getDirectTemplateSlots

    public Collection getDirectTemplateSlots(Cls cls)

  Specified by:
    `getDirectTemplateSlots` in interface `KnowledgeBase`

### getDirectTemplateSlotValues

    public List getDirectTemplateSlotValues(Cls cls,
                                            Slot slot)

  Specified by:
    `getDirectTemplateSlotValues` in interface `KnowledgeBase`

### getInstanceCount

    public int getInstanceCount(Cls cls)

  Specified by:
    `getInstanceCount` in interface `KnowledgeBase`

### getSuperclasses

    public Collection getSuperclasses(Cls cls)

  Specified by:
    `getSuperclasses` in interface `KnowledgeBase`

### getTemplateFacets

    public Collection getTemplateFacets(Cls cls,
                                        Slot slot)

  Specified by:
    `getTemplateFacets` in interface `KnowledgeBase`

### getTemplateFacetValue

    public Object getTemplateFacetValue(Cls cls,
                                        Slot slot,
                                        Facet facet)

  Specified by:
    `getTemplateFacetValue` in interface `KnowledgeBase`

### getTemplateFacetValues

    public Collection getTemplateFacetValues(Cls cls,
                                             Slot slot,
                                             Facet facet)

  Specified by:
    `getTemplateFacetValues` in interface `KnowledgeBase`

### getTemplateSlotAllowedClses

    public Collection getTemplateSlotAllowedClses(Cls cls,
                                                  Slot slot)

  Specified by:
    `getTemplateSlotAllowedClses` in interface `KnowledgeBase`

### getTemplateSlotAllowedParents

    public Collection getTemplateSlotAllowedParents(Cls cls,
                                                    Slot slot)

  Specified by:
    `getTemplateSlotAllowedParents` in interface `KnowledgeBase`

### getTemplateSlotAllowedValues

    public Collection getTemplateSlotAllowedValues(Cls cls,
                                                   Slot slot)

  Specified by:
    `getTemplateSlotAllowedValues` in interface `KnowledgeBase`

### getTemplateSlotAllowsMultipleValues

    public boolean getTemplateSlotAllowsMultipleValues(Cls cls,
                                                       Slot slot)

  Specified by:
    `getTemplateSlotAllowsMultipleValues` in interface `KnowledgeBase`

### getTemplateSlotDefaultValues

    public Collection getTemplateSlotDefaultValues(Cls cls,
                                                   Slot slot)

  Specified by:
    `getTemplateSlotDefaultValues` in interface `KnowledgeBase`

### getTemplateSlotDocumentation

    public Collection getTemplateSlotDocumentation(Cls cls,
                                                   Slot slot)

  Specified by:
    `getTemplateSlotDocumentation` in interface `KnowledgeBase`

### getTemplateSlotMaximumCardinality

    public int getTemplateSlotMaximumCardinality(Cls cls,
                                                 Slot slot)

  Specified by:
    `getTemplateSlotMaximumCardinality` in interface `KnowledgeBase`

### getTemplateSlotMaximumCardinality2

    public Integer getTemplateSlotMaximumCardinality2(Cls cls,
                                                      Slot slot)

### getTemplateSlotMinimumCardinality2

    public Integer getTemplateSlotMinimumCardinality2(Cls cls,
                                                      Slot slot)

### getTemplateSlotMaximumValue

    public Number getTemplateSlotMaximumValue(Cls cls,
                                              Slot slot)

  Specified by:
    `getTemplateSlotMaximumValue` in interface `KnowledgeBase`

### getTemplateSlotMinimumCardinality

    public int getTemplateSlotMinimumCardinality(Cls cls,
                                                 Slot slot)

  Specified by:
    `getTemplateSlotMinimumCardinality` in interface `KnowledgeBase`

### getTemplateSlotMinimumValue

    public Number getTemplateSlotMinimumValue(Cls cls,
                                              Slot slot)

  Specified by:
    `getTemplateSlotMinimumValue` in interface `KnowledgeBase`

### getTemplateSlotValue

    public Object getTemplateSlotValue(Cls cls,
                                       Slot slot)

  Specified by:
    `getTemplateSlotValue` in interface `KnowledgeBase`

### getTemplateSlotValues

    public Collection getTemplateSlotValues(Cls cls,
                                            Slot slot)

  Specified by:
    `getTemplateSlotValues` in interface `KnowledgeBase`

### getTemplateSlotValueType

    public ValueType getTemplateSlotValueType(Cls cls,
                                              Slot slot)

  Specified by:
    `getTemplateSlotValueType` in interface `KnowledgeBase`

### hasDirectlyOverriddenTemplateFacet

    public boolean hasDirectlyOverriddenTemplateFacet(Cls cls,
                                                      Slot slot,
                                                      Facet facet)

  Specified by:
    `hasDirectlyOverriddenTemplateFacet` in interface `KnowledgeBase`

### hasDirectlyOverriddenTemplateSlot

    public boolean hasDirectlyOverriddenTemplateSlot(Cls cls,
                                                     Slot slot)

  Specified by:
    `hasDirectlyOverriddenTemplateSlot` in interface `KnowledgeBase`

### getDirectlyOverriddenTemplateSlots

    public Collection getDirectlyOverriddenTemplateSlots(Cls cls)

  Specified by:
    `getDirectlyOverriddenTemplateSlots` in interface `KnowledgeBase`

### getDirectlyOverriddenTemplateFacets

    public Collection getDirectlyOverriddenTemplateFacets(Cls cls,
                                                          Slot slot)

  Specified by:
    `getDirectlyOverriddenTemplateFacets` in interface `KnowledgeBase`

### hasDirectSuperslot

    public boolean hasDirectSuperslot(Slot slot,
                                      Slot superslot)

  Specified by:
    `hasDirectSuperslot` in interface `KnowledgeBase`

### hasSuperslot

    public boolean hasSuperslot(Slot slot,
                                Slot superslot)

  Specified by:
    `hasSuperslot` in interface `KnowledgeBase`

### hasDirectSuperclass

    public boolean hasDirectSuperclass(Cls cls,
                                       Cls superclass)

  Specified by:
    `hasDirectSuperclass` in interface `KnowledgeBase`

### hasDirectTemplateSlot

    public boolean hasDirectTemplateSlot(Cls cls,
                                         Slot slot)

  Specified by:
    `hasDirectTemplateSlot` in interface `KnowledgeBase`

### hasInheritedTemplateSlot

    public boolean hasInheritedTemplateSlot(Cls cls,
                                            Slot slot)

  Specified by:
    `hasInheritedTemplateSlot` in interface `KnowledgeBase`

### getInheritedTemplateSlots

    public Collection getInheritedTemplateSlots(Cls cls)

### hasOverriddenTemplateSlot

    public boolean hasOverriddenTemplateSlot(Cls cls,
                                             Slot slot)

  Specified by:
    `hasOverriddenTemplateSlot` in interface `KnowledgeBase`

### getOverriddenTemplateSlots

    public Collection getOverriddenTemplateSlots(Cls cls)

### hasOverriddenTemplateFacet

    public boolean hasOverriddenTemplateFacet(Cls cls,
                                              Slot slot,
                                              Facet facet)

  Specified by:
    `hasOverriddenTemplateFacet` in interface `KnowledgeBase`

### getOverriddenTemplateFacets

    public Collection getOverriddenTemplateFacets(Cls cls,
                                                  Slot slot)

  Specified by:
    `getOverriddenTemplateFacets` in interface `KnowledgeBase`

### removeTemplateFacetOverrides

    @Deprecated
    public void removeTemplateFacetOverrides(Cls cls,
                                                        Slot slot)

  Deprecated. renamed to #removeDirectTemplateFacetOverrides

  Specified by:
    `removeTemplateFacetOverrides` in interface `KnowledgeBase`

### removeDirectTemplateFacetOverrides

    public void removeDirectTemplateFacetOverrides(Cls cls,
                                                   Slot slot)

### hasSuperclass

    public boolean hasSuperclass(Cls cls,
                                 Cls superclass)

  Specified by:
    `hasSuperclass` in interface `KnowledgeBase`

### hasTemplateSlot

    public boolean hasTemplateSlot(Cls cls,
                                   Slot slot)

  Specified by:
    `hasTemplateSlot` in interface `KnowledgeBase`

### isAbstract

    public boolean isAbstract(Cls cls)

  Specified by:
    `isAbstract` in interface `KnowledgeBase`

### isMetaCls

    public boolean isMetaCls(Cls cls)

  Specified by:
    `isMetaCls` in interface `KnowledgeBase`

### moveDirectSubclass

    public void moveDirectSubclass(Cls cls,
                                   Cls subclass,
                                   Cls afterclass)

  Specified by:
    `moveDirectSubclass` in interface `KnowledgeBase`

### moveDirectSubclass

    public void moveDirectSubclass(Cls cls,
                                   Cls subclass,
                                   int index)

### moveDirectSubslot

    public void moveDirectSubslot(Slot slot,
                                  Slot subslot,
                                  Slot afterslot)

  Specified by:
    `moveDirectSubslot` in interface `KnowledgeBase`

### moveDirectSubslot

    public void moveDirectSubslot(Slot slot,
                                  Slot subslot,
                                  int index)

### moveDirectTemplateSlot

    public void moveDirectTemplateSlot(Cls cls,
                                       Slot slot,
                                       int toIndex)

  Specified by:
    `moveDirectTemplateSlot` in interface `KnowledgeBase`

### setAbstract

    public void setAbstract(Cls cls,
                            boolean isAbstract)

  Specified by:
    `setAbstract` in interface `KnowledgeBase`

### setDirectTypeOfSubclasses

    public void setDirectTypeOfSubclasses(Cls cls,
                                          Cls type)

  Specified by:
    `setDirectTypeOfSubclasses` in interface `KnowledgeBase`

### setTemplateFacetValue

    @Deprecated
    public void setTemplateFacetValue(Cls cls,
                                                 Slot slot,
                                                 Facet facet,
                                                 Object value)

  Deprecated. renamed to #setDirectTemplateFacetValue

  Specified by:
    `setTemplateFacetValue` in interface `KnowledgeBase`

### setDirectTemplateFacetValue

    public void setDirectTemplateFacetValue(Cls cls,
                                            Slot slot,
                                            Facet facet,
                                            Object value)

### setTemplateFacetValues

    @Deprecated
    public void setTemplateFacetValues(Cls cls,
                                                  Slot slot,
                                                  Facet facet,
                                                  Collection values)

  Deprecated. renamed to #setDirectTemplateFacetValues

  Specified by:
    `setTemplateFacetValues` in interface `KnowledgeBase`

### setDirectTemplateFacetValues

    public void setDirectTemplateFacetValues(Cls cls,
                                             Slot slot,
                                             Facet facet,
                                             Collection values)

### setTemplateSlotAllowedClses

    public void setTemplateSlotAllowedClses(Cls cls,
                                            Slot slot,
                                            Collection values)

  Specified by:
    `setTemplateSlotAllowedClses` in interface `KnowledgeBase`

### setTemplateSlotAllowedParents

    public void setTemplateSlotAllowedParents(Cls cls,
                                              Slot slot,
                                              Collection values)

  Specified by:
    `setTemplateSlotAllowedParents` in interface `KnowledgeBase`

### setTemplateSlotAllowedValues

    public void setTemplateSlotAllowedValues(Cls cls,
                                             Slot slot,
                                             Collection values)

  Specified by:
    `setTemplateSlotAllowedValues` in interface `KnowledgeBase`

### setTemplateSlotAllowsMultipleValues

    public void setTemplateSlotAllowsMultipleValues(Cls cls,
                                                    Slot slot,
                                                    boolean allowsMultiple)

  Specified by:
    `setTemplateSlotAllowsMultipleValues` in interface `KnowledgeBase`

### setTemplateSlotDefaultValues

    public void setTemplateSlotDefaultValues(Cls cls,
                                             Slot slot,
                                             Collection values)

  Specified by:
    `setTemplateSlotDefaultValues` in interface `KnowledgeBase`

### setTemplateSlotDocumentation

    public void setTemplateSlotDocumentation(Cls cls,
                                             Slot slot,
                                             String doc)

  Specified by:
    `setTemplateSlotDocumentation` in interface `KnowledgeBase`

### setTemplateSlotDocumentation

    public void setTemplateSlotDocumentation(Cls cls,
                                             Slot slot,
                                             Collection docs)

  Specified by:
    `setTemplateSlotDocumentation` in interface `KnowledgeBase`

### setTemplateSlotMaximumCardinality

    public void setTemplateSlotMaximumCardinality(Cls cls,
                                                  Slot slot,
                                                  int value)

  Specified by:
    `setTemplateSlotMaximumCardinality` in interface `KnowledgeBase`

### setTemplateSlotMaximumValue

    public void setTemplateSlotMaximumValue(Cls cls,
                                            Slot slot,
                                            Number value)

  Specified by:
    `setTemplateSlotMaximumValue` in interface `KnowledgeBase`

### setTemplateSlotMinimumCardinality

    public void setTemplateSlotMinimumCardinality(Cls cls,
                                                  Slot slot,
                                                  int value)

  Specified by:
    `setTemplateSlotMinimumCardinality` in interface `KnowledgeBase`

### setTemplateSlotMinimumValue

    public void setTemplateSlotMinimumValue(Cls cls,
                                            Slot slot,
                                            Number value)

  Specified by:
    `setTemplateSlotMinimumValue` in interface `KnowledgeBase`

### setTemplateSlotValue

    public void setTemplateSlotValue(Cls cls,
                                     Slot slot,
                                     Object value)

  Specified by:
    `setTemplateSlotValue` in interface `KnowledgeBase`

### setTemplateSlotValues

    @Deprecated
    public void setTemplateSlotValues(Cls cls,
                                                 Slot slot,
                                                 Collection values)

  Deprecated. renamed to #setDirectTemplateSlotValues

  Specified by:
    `setTemplateSlotValues` in interface `KnowledgeBase`

### setDirectTemplateSlotValues

    public void setDirectTemplateSlotValues(Cls cls,
                                            Slot slot,
                                            Collection values)

### setTemplateSlotValueType

    public void setTemplateSlotValueType(Cls cls,
                                         Slot slot,
                                         ValueType type)

  Specified by:
    `setTemplateSlotValueType` in interface `KnowledgeBase`

### addInstance

    public void addInstance(Instance instance,
                            String name,
                            Cls type,
                            boolean isNew)

  TODO: Implement addInstance

  Specified by:
    `addInstance` in interface `KnowledgeBase`

### getBrowserText

    public String getBrowserText(Instance instance)

  Specified by:
    `getBrowserText` in interface `KnowledgeBase`

### getMissingTypeString

    protected String getMissingTypeString(Instance instance)

### getDisplaySlotNotSetString

    protected String getDisplaySlotNotSetString(Instance instance)

### getDisplaySlotPatternValueNotSetString

    protected String getDisplaySlotPatternValueNotSetString(Instance instance,
                                                            BrowserSlotPattern slotPattern)

### toString

    protected String toString(BrowserSlotPattern pattern)

### toString

    protected String toString(Object o)

### toStringForFrame

    protected String toStringForFrame(Frame frame)

### toStringForObject

    protected String toStringForObject(Object o)

### getDirectTypes

    public Collection getDirectTypes(Instance instance)

  Specified by:
    `getDirectTypes` in interface `KnowledgeBase`

### hasDirectType

    public boolean hasDirectType(Instance instance,
                                 Cls cls)

  Specified by:
    `hasDirectType` in interface `KnowledgeBase`

### hasType

    public boolean hasType(Instance instance,
                           Cls cls)

  Specified by:
    `hasType` in interface `KnowledgeBase`

### getTypes

    public Collection getTypes(Instance instance)

### setDirectType

    public Instance setDirectType(Instance instance,
                                  Cls type)

  TODO setDirectType should return void

  Specified by:
    `setDirectType` in interface `KnowledgeBase`

### setDirectTypes

    public Instance setDirectTypes(Instance instance,
                                   Collection newTypes)

  Specified by:
    `setDirectTypes` in interface `KnowledgeBase`

### addDirectTypes

    public void addDirectTypes(Instance instance,
                               Collection types)

### removeDirectTypes

    public void removeDirectTypes(Instance instance,
                                  Collection types)

### addDirectSuperslot

    public void addDirectSuperslot(Slot slot,
                                   Slot superslot)

  Specified by:
    `addDirectSuperslot` in interface `KnowledgeBase`

### getAllowedClses

    public Collection getAllowedClses(Slot slot)

  Specified by:
    `getAllowedClses` in interface `KnowledgeBase`

### getAllowedParents

    public Collection getAllowedParents(Slot slot)

  Specified by:
    `getAllowedParents` in interface `KnowledgeBase`

### getAllowedValues

    public Collection getAllowedValues(Slot slot)

  Specified by:
    `getAllowedValues` in interface `KnowledgeBase`

### getAllowsMultipleValues

    public boolean getAllowsMultipleValues(Slot slot)

  Specified by:
    `getAllowsMultipleValues` in interface `KnowledgeBase`

### getAssociatedFacet

    public Facet getAssociatedFacet(Slot slot)

  Specified by:
    `getAssociatedFacet` in interface `KnowledgeBase`

### getDefaultValues

    public Collection getDefaultValues(Slot slot)

  Specified by:
    `getDefaultValues` in interface `KnowledgeBase`

### getDirectSubslotCount

    public int getDirectSubslotCount(Slot slot)

  Specified by:
    `getDirectSubslotCount` in interface `KnowledgeBase`

### getDirectSubslots

    public Collection getDirectSubslots(Slot slot)

  Specified by:
    `getDirectSubslots` in interface `KnowledgeBase`

### getDirectSuperslots

    public Collection getDirectSuperslots(Slot slot)

  Specified by:
    `getDirectSuperslots` in interface `KnowledgeBase`

### getDirectSuperslotCount

    public int getDirectSuperslotCount(Slot slot)

  Specified by:
    `getDirectSuperslotCount` in interface `KnowledgeBase`

### getInverseSlot

    public Slot getInverseSlot(Slot slot)

  Specified by:
    `getInverseSlot` in interface `KnowledgeBase`

### getMaximumCardinality2

    public Integer getMaximumCardinality2(Slot slot)

### getMaximumCardinality

    public int getMaximumCardinality(Slot slot)

  Specified by:
    `getMaximumCardinality` in interface `KnowledgeBase`

### getMaximumValue

    public Number getMaximumValue(Slot slot)

  Specified by:
    `getMaximumValue` in interface `KnowledgeBase`

### getMinimumCardinality

    public int getMinimumCardinality(Slot slot)

  Specified by:
    `getMinimumCardinality` in interface `KnowledgeBase`

### getMinimumValue

    public Number getMinimumValue(Slot slot)

  Specified by:
    `getMinimumValue` in interface `KnowledgeBase`

### getSubslots

    public Collection getSubslots(Slot slot)

  Specified by:
    `getSubslots` in interface `KnowledgeBase`

### getSuperslots

    public Collection getSuperslots(Slot slot)

  Specified by:
    `getSuperslots` in interface `KnowledgeBase`

### getDirectDomain

    public Collection getDirectDomain(Slot slot)

  Specified by:
    `getDirectDomain` in interface `KnowledgeBase`

### getDomain

    public Collection getDomain(Slot slot)

  Specified by:
    `getDomain` in interface `KnowledgeBase`

### getValues

    public Collection getValues(Slot slot)

  Specified by:
    `getValues` in interface `KnowledgeBase`

### getValueType

    public ValueType getValueType(Slot slot)

  Specified by:
    `getValueType` in interface `KnowledgeBase`

### hasSlotValueAtSomeFrame

    public boolean hasSlotValueAtSomeFrame(Slot slot)

  TODO implement or deprecate hasSlotValueAtSomeFrame

  Specified by:
    `hasSlotValueAtSomeFrame` in interface `KnowledgeBase`

### removeDirectSuperslot

    public void removeDirectSuperslot(Slot slot,
                                      Slot superslot)

  Specified by:
    `removeDirectSuperslot` in interface `KnowledgeBase`

### setAllowedClses

    public void setAllowedClses(Slot slot,
                                Collection clses)

  Specified by:
    `setAllowedClses` in interface `KnowledgeBase`

### setAllowedParents

    public void setAllowedParents(Slot slot,
                                  Collection parents)

  Specified by:
    `setAllowedParents` in interface `KnowledgeBase`

### setAllowedValues

    public void setAllowedValues(Slot slot,
                                 Collection values)

  Specified by:
    `setAllowedValues` in interface `KnowledgeBase`

### setAllowsMultipleValues

    public void setAllowsMultipleValues(Slot slot,
                                        boolean allowsMultiple)

  Specified by:
    `setAllowsMultipleValues` in interface `KnowledgeBase`

### setAssociatedFacet

    public void setAssociatedFacet(Slot slot,
                                   Facet facet)

  Specified by:
    `setAssociatedFacet` in interface `KnowledgeBase`

### setDefaultValues

    public void setDefaultValues(Slot slot,
                                 Collection values)

  Specified by:
    `setDefaultValues` in interface `KnowledgeBase`

### setDirectTypeOfSubslots

    public void setDirectTypeOfSubslots(Slot slot,
                                        Cls type)

  TODO do we need this?

  Specified by:
    `setDirectTypeOfSubslots` in interface `KnowledgeBase`

### setInverseSlot

    public void setInverseSlot(Slot slot,
                               Slot inverseSlot)

  Specified by:
    `setInverseSlot` in interface `KnowledgeBase`

### setMaximumCardinality

    public void setMaximumCardinality(Slot slot,
                                      int max)

  Specified by:
    `setMaximumCardinality` in interface `KnowledgeBase`

### setMaximumValue

    public void setMaximumValue(Slot slot,
                                Number max)

  Specified by:
    `setMaximumValue` in interface `KnowledgeBase`

### setMinimumCardinality

    public void setMinimumCardinality(Slot slot,
                                      int min)

  Specified by:
    `setMinimumCardinality` in interface `KnowledgeBase`

### setMinimumValue

    public void setMinimumValue(Slot slot,
                                Number min)

  Specified by:
    `setMinimumValue` in interface `KnowledgeBase`

### setValues

    public void setValues(Slot slot,
                          Collection values)

  Specified by:
    `setValues` in interface `KnowledgeBase`

### setValueType

    public void setValueType(Slot slot,
                             ValueType newType)

  Specified by:
    `setValueType` in interface `KnowledgeBase`

### setUserName

    public void setUserName(String userName)

### addFrameListener

    public void addFrameListener(Frame frame,
                                 FrameListener listener)

  Description copied from interface: `KnowledgeBase`
  add a listener fro frame evnets for a particular frame

  Specified by:
    `addFrameListener` in interface `KnowledgeBase`

### addFrameListener

    public void addFrameListener(FrameListener listener)

  Description copied from interface: `KnowledgeBase`
  add a listener for frame events for all frames

  Specified by:
    `addFrameListener` in interface `KnowledgeBase`

### removeFrameListener

    public void removeFrameListener(Frame frame,
                                    FrameListener listener)

  Specified by:
    `removeFrameListener` in interface `KnowledgeBase`

### removeFrameListener

    public void removeFrameListener(FrameListener listener)

  Specified by:
    `removeFrameListener` in interface `KnowledgeBase`

### addSlotListener

    public void addSlotListener(Slot slot,
                                SlotListener listener)

  Specified by:
    `addSlotListener` in interface `KnowledgeBase`

### addSlotListener

    public void addSlotListener(SlotListener listener)

  Specified by:
    `addSlotListener` in interface `KnowledgeBase`

### removeSlotListener

    public void removeSlotListener(Slot slot,
                                   SlotListener listener)

  Specified by:
    `removeSlotListener` in interface `KnowledgeBase`

### removeSlotListener

    public void removeSlotListener(SlotListener listener)

  Specified by:
    `removeSlotListener` in interface `KnowledgeBase`

### addInstanceListener

    public void addInstanceListener(Instance instance,
                                    InstanceListener listener)

  Specified by:
    `addInstanceListener` in interface `KnowledgeBase`

### addInstanceListener

    public void addInstanceListener(InstanceListener listener)

  Specified by:
    `addInstanceListener` in interface `KnowledgeBase`

### removeInstanceListener

    public void removeInstanceListener(Instance instance,
                                       InstanceListener listener)

  Specified by:
    `removeInstanceListener` in interface `KnowledgeBase`

### removeInstanceListener

    public void removeInstanceListener(InstanceListener listener)

  Specified by:
    `removeInstanceListener` in interface `KnowledgeBase`

### addClsListener

    public void addClsListener(ClsListener listener)

  Description copied from interface: `KnowledgeBase`
  Add a listener for class events for all classes

  Specified by:
    `addClsListener` in interface `KnowledgeBase`

### addClsListener

    public void addClsListener(Cls cls,
                               ClsListener listener)

  Description copied from interface: `KnowledgeBase`
  Add a listener for class events for a particular class

  Specified by:
    `addClsListener` in interface `KnowledgeBase`

### removeClsListener

    public void removeClsListener(Cls cls,
                                  ClsListener listener)

  Specified by:
    `removeClsListener` in interface `KnowledgeBase`

### removeClsListener

    public void removeClsListener(ClsListener listener)

  Specified by:
    `removeClsListener` in interface `KnowledgeBase`

### addKnowledgeBaseListener

    public void addKnowledgeBaseListener(KnowledgeBaseListener listener)

  Specified by:
    `addKnowledgeBaseListener` in interface `KnowledgeBase`

### removeKnowledgeBaseListener

    public void removeKnowledgeBaseListener(KnowledgeBaseListener listener)

  Specified by:
    `removeKnowledgeBaseListener` in interface `KnowledgeBase`

### addFacetListener

    public void addFacetListener(Facet facet,
                                 FacetListener listener)

  Description copied from interface: `KnowledgeBase`
  Add a listener for facet events for a particular facet

  Specified by:
    `addFacetListener` in interface `KnowledgeBase`

### addFacetListener

    public void addFacetListener(FacetListener listener)

  Description copied from interface: `KnowledgeBase`
  Add a listener for facet events for all facets

  Specified by:
    `addFacetListener` in interface `KnowledgeBase`

### removeFacetListener

    public void removeFacetListener(Facet facet,
                                    FacetListener listener)

  Specified by:
    `removeFacetListener` in interface `KnowledgeBase`

### removeFacetListener

    public void removeFacetListener(FacetListener listener)

  Specified by:
    `removeFacetListener` in interface `KnowledgeBase`

### addServerProjectListener

    public void addServerProjectListener(ServerProjectListener listener)

  Specified by:
    `addServerProjectListener` in interface `KnowledgeBase`

### removeServerProjectListener

    public void removeServerProjectListener(ServerProjectListener listener)

  Specified by:
    `removeServerProjectListener` in interface `KnowledgeBase`

### toString

    public String toString()

  Overrides:
    `toString` in class `Object`

### getCurrentUsers

    public Collection getCurrentUsers()

  Specified by:
    `getCurrentUsers` in interface `KnowledgeBase`

### beginTransaction

    public boolean beginTransaction(String name)

  Description copied from interface: `KnowledgeBase`
  Tells the system that one or more edit actions will follow which should be handled as a unit for undo. Editing components should wrap set/add/remove calls to any resource in a `beginTransaction() - commitTransaction() or rollbackTransaction()` block.

  Specified by:
    `beginTransaction` in interface `KnowledgeBase`
  Parameters:
    `name` - the human-readable name of the following transaction
  Returns:
    true
  See Also:
    `KnowledgeBase.endTransaction()`

### beginTransaction

    public boolean beginTransaction(String name,
                                    String appliedToFrameName)

  Specified by:
    `beginTransaction` in interface `KnowledgeBase`

### commitTransaction

    public boolean commitTransaction()

  Description copied from interface: `KnowledgeBase`
  Commits the recently opened transaction

  Specified by:
    `commitTransaction` in interface `KnowledgeBase`
  Returns:
    true - if commit suceeded false - otherwise
  See Also:
    `KnowledgeBase.beginTransaction(java.lang.String)`

### rollbackTransaction

    public boolean rollbackTransaction()

  Description copied from interface: `KnowledgeBase`
  Rolls back the recently opened transaction

  Specified by:
    `rollbackTransaction` in interface `KnowledgeBase`
  Returns:
    true - if rollback succeeded false - otherwise
  See Also:
    `KnowledgeBase.beginTransaction(java.lang.String)`

### endTransaction

    @Deprecated
    public boolean endTransaction(boolean doCommit)

  Deprecated. Use #commitTransaction or #rollbackTransaction

  Specified by:
    `endTransaction` in interface `KnowledgeBase`
  Parameters:
    `doCommit` - true: commits transaction false: rolls back transaction
  Returns:
    true - if operation succeeded false - if operation failed

### endTransaction

    @Deprecated
    public boolean endTransaction()

  Deprecated. Use #commitTransaction

  Specified by:
    `endTransaction` in interface `KnowledgeBase`
  Returns:
    true - if commit succeeds false - otherwise
  See Also:
    `KnowledgeBase.beginTransaction(java.lang.String)`

### setFrameFactory

    public void setFrameFactory(FrameFactory factory)

  Specified by:
    `setFrameFactory` in interface `KnowledgeBase`

### getCommandManager

    public CommandManager getCommandManager()

  Specified by:
    `getCommandManager` in interface `KnowledgeBase`

### setFrameNameValidator

    public void setFrameNameValidator(FrameNameValidator validator)

  Specified by:
    `setFrameNameValidator` in interface `KnowledgeBase`

### isValidFrameName

    public boolean isValidFrameName(String name,
                                    Frame frame)

  Specified by:
    `isValidFrameName` in interface `KnowledgeBase`

### getInvalidFrameNameDescription

    public String getInvalidFrameNameDescription(String name,
                                                 Frame frame)

  Specified by:
    `getInvalidFrameNameDescription` in interface `KnowledgeBase`

### setPollForEvents

    public void setPollForEvents(boolean b)

  Specified by:
    `setPollForEvents` in interface `KnowledgeBase`

### setDirectBrowserSlot

    @Deprecated
    public void setDirectBrowserSlot(Cls cls,
                                                Slot slot)

  Deprecated.

  Specified by:
    `setDirectBrowserSlot` in interface `KnowledgeBase`
  Parameters:
    `cls` -
    `slot` -

### setDirectBrowserSlotPattern

    public void setDirectBrowserSlotPattern(Cls cls,
                                            BrowserSlotPattern slotPattern)

  Specified by:
    `setDirectBrowserSlotPattern` in interface `KnowledgeBase`

### removeFrameStore

    public void removeFrameStore(FrameStore frameStore)

  Specified by:
    `removeFrameStore` in interface `KnowledgeBase`

### insertFrameStore

    public void insertFrameStore(FrameStore newFrameStore)

  Description copied from interface: `KnowledgeBase`
  Inserts a new frame store into the front of the delegation chain.

  Specified by:
    `insertFrameStore` in interface `KnowledgeBase`

### insertFrameStore

    public void insertFrameStore(FrameStore newFrameStore,
                                 int position)

  Description copied from interface: `KnowledgeBase`
  Inserts a new frame store into the delegation chain.

  Specified by:
    `insertFrameStore` in interface `KnowledgeBase`
    `position` - Position in the frame store list to insert this frame store.

### getFrameStores

    public List<FrameStore> getFrameStores()

  Description copied from interface: `KnowledgeBase`
  Returns a list of FrameStores available to the system. This includes both enabled and disabled frame stores.

  Specified by:
    `getFrameStores` in interface `KnowledgeBase`
  Returns:
    List of #FrameStore

### setTerminalFrameStore

    public void setTerminalFrameStore(FrameStore store)

### getTerminalFrameStore

    public FrameStore getTerminalFrameStore()

### clearAllListeners

    public void clearAllListeners()

  Specified by:
    `clearAllListeners` in interface `KnowledgeBase`

### getFrameCounts

    public FrameCounts getFrameCounts()

  Specified by:
    `getFrameCounts` in interface `KnowledgeBase`

### getDirectBrowserSlotPattern

    public BrowserSlotPattern getDirectBrowserSlotPattern(Cls cls)

  Specified by:
    `getDirectBrowserSlotPattern` in interface `KnowledgeBase`

### setDirectBrowserTextPattern

    public void setDirectBrowserTextPattern(Cls cls,
                                            BrowserSlotPattern pattern)

### getDirectOwnSlotValuesClosure

    public Set getDirectOwnSlotValuesClosure(Frame frame,
                                             Slot slot)

  Specified by:
    `getDirectOwnSlotValuesClosure` in interface `KnowledgeBase`

### getValueChecking

    @Deprecated
    public boolean getValueChecking()

  Deprecated. Use #getFacetCheckingEnabled

  Specified by:
    `getValueChecking` in interface `KnowledgeBase`

### getFacetCheckingEnabled

    public boolean getFacetCheckingEnabled()

### startJournaling

    public void startJournaling(URI journal)

  Specified by:
    `startJournaling` in interface `KnowledgeBase`

### stopJournaling

    public void stopJournaling()

  Specified by:
    `stopJournaling` in interface `KnowledgeBase`

### setGenerateDeletingFrameEventsEnabled

    public boolean setGenerateDeletingFrameEventsEnabled(boolean enabled)

  Specified by:
    `setGenerateDeletingFrameEventsEnabled` in interface `KnowledgeBase`

### flushCache

    public void flushCache()

  Specified by:
    `flushCache` in interface `KnowledgeBase`

### getReifiedRelationCls

    public Cls getReifiedRelationCls()

  Specified by:
    `getReifiedRelationCls` in interface `KnowledgeBase`

### getReifedRelationFromSlot

    public Slot getReifedRelationFromSlot()

  Specified by:
    `getReifedRelationFromSlot` in interface `KnowledgeBase`

### getReifedRelationToSlot

    public Slot getReifedRelationToSlot()

  Specified by:
    `getReifedRelationToSlot` in interface `KnowledgeBase`

### addTransactionListener

    public void addTransactionListener(TransactionListener listener)

  Specified by:
    `addTransactionListener` in interface `KnowledgeBase`

### removeTransactionListener

    public void removeTransactionListener(TransactionListener listener)

  Specified by:
    `removeTransactionListener` in interface `KnowledgeBase`

### executeQuery

    public Collection<Frame> executeQuery(Query q)

  Specified by:
    `executeQuery` in interface `KnowledgeBase`

### getCacheMachine

    public ServerCacheStateMachine getCacheMachine()

### setCacheMachine

    public void setCacheMachine(ServerCacheStateMachine machine)

### rename

    public Frame rename(Frame frame,
                        String name)

  Specified by:
    `rename` in interface `KnowledgeBase`

### assertFrameName

    public void assertFrameName(Frame frame)

  Specified by:
    `assertFrameName` in interface `KnowledgeBase`

Overview | Package | Class | Tree | Deprecated | Index | Help
| Protege 3.4 rc2
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug report or feature request
Protégé is a trademark of Stanford University.
Copyright (c) 1998-2009 Stanford University.